#include <stdint.h>  /* uintN_t */
#include <stdio.h>   /* printf() */

void foo(uint32_t *parent_esp);
void bar(uint32_t *parent_esp);

void foo(uint32_t *parent_esp) {

    register uint32_t *ebp asm ("ebp");
    register uint32_t *esp asm ("esp");

    uint32_t *i;
    uint32_t *j;

    for (i = parent_esp; i>ebp; i--) {
        printf("%p: 0x%x\n", (void*)i, *i);
    }

    /* printf("foo() ret addr: %p\n", __builtin_return_address(0)); */

    printf("%p == EBP in foo()\n", (void*)ebp);
    
    for (j = ebp; j>esp; j--) {
        printf("%p: 0x%x\n", (void*)j, *j);
    }

    printf("%p == ESP in foo()\n", (void*)esp);

    bar(esp);

    return;

}

void bar(uint32_t *parent_esp) {

    register uint32_t *ebp asm ("ebp");
    register uint32_t *esp asm ("esp");

    uint32_t *i;
    uint32_t *j;

    for (i = parent_esp; i>ebp; i--) {
        printf("%p: 0x%x\n", (void*)i, *i);
    }

    /* printf("bar() ret addr: %p\n", __builtin_return_address(0)); */

    printf("%p == EBP in bar()\n", (void*)ebp);
    
    for (j = ebp; j>esp; j--) {
        printf("%p: 0x%x\n", (void*)j, *j);
    }

    printf("%p == ESP in bar()\n", (void*)esp);

    return;

}

int main() {

    uint32_t *j;

    register uint32_t *ebp asm ("ebp");
    register uint32_t *esp asm ("esp");

    /* printf("main() ret addr: %p\n", __builtin_return_address(0)); */

    printf("%p == EBP in main()\n", (void*)ebp);

    for (j = ebp; j>esp; j--) {
        printf("%p: 0x%x\n", (void*)j, *j);
    }

    printf("%p == ESP in main()\n", (void*)esp);

    foo(esp);

    return 0;

}